# booklify_api (EXPERIMENTAL)
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Generator version: 7.4.0
- Build package: org.openapitools.codegen.languages.DartDioClientCodegen

## Requirements

* Dart 2.15.0+ or Flutter 2.8.0+
* Dio 5.0.0+ (https://pub.dev/packages/dio)

## Installation & Usage

### pub.dev
To use the package from [pub.dev](https://pub.dev), please include the following in pubspec.yaml
```yaml
dependencies:
  booklify_api: 0.0.1
```

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```yaml
dependencies:
  booklify_api:
    git:
      url: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
      #ref: main
```

### Local development
To use the package from your local drive, please include the following in pubspec.yaml
```yaml
dependencies:
  booklify_api:
    path: /path/to/booklify_api
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:booklify_api/booklify_api.dart';


final api = BooklifyApi().getAuthApi();
final ChangePasswordDto changePasswordDto = ; // ChangePasswordDto | 

try {
    api.authControllerChangePassword(changePasswordDto);
} catch on DioException (e) {
    print("Exception when calling AuthApi->authControllerChangePassword: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
[*AuthApi*](doc/AuthApi.md) | [**authControllerChangePassword**](doc/AuthApi.md#authcontrollerchangepassword) | **POST** /auth/password | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerDeleteProfile**](doc/AuthApi.md#authcontrollerdeleteprofile) | **DELETE** /auth/profile | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerGetExport**](doc/AuthApi.md#authcontrollergetexport) | **GET** /auth/export | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerGetNewToken**](doc/AuthApi.md#authcontrollergetnewtoken) | **GET** /auth/token | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerGetProfile**](doc/AuthApi.md#authcontrollergetprofile) | **GET** /auth/profile | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerGetSession**](doc/AuthApi.md#authcontrollergetsession) | **GET** /auth/session | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerGetSessions**](doc/AuthApi.md#authcontrollergetsessions) | **GET** /auth/sessions | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerInvalidateSession**](doc/AuthApi.md#authcontrollerinvalidatesession) | **DELETE** /auth/session/{id} | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerRefreshToken**](doc/AuthApi.md#authcontrollerrefreshtoken) | **GET** /auth/refresh | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerRequestResetPassword**](doc/AuthApi.md#authcontrollerrequestresetpassword) | **POST** /auth/request-reset | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerResend**](doc/AuthApi.md#authcontrollerresend) | **POST** /auth/resend | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerResetPassword**](doc/AuthApi.md#authcontrollerresetpassword) | **POST** /auth/reset | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerSignIn**](doc/AuthApi.md#authcontrollersignin) | **POST** /auth/login | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerSignOut**](doc/AuthApi.md#authcontrollersignout) | **POST** /auth/logout | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerSignUp**](doc/AuthApi.md#authcontrollersignup) | **POST** /auth/signup | 
[*AuthApi*](doc/AuthApi.md) | [**authControllerVerify**](doc/AuthApi.md#authcontrollerverify) | **GET** /auth/verify | 
[*AuthorsApi*](doc/AuthorsApi.md) | [**authorsControllerGetAuthor**](doc/AuthorsApi.md#authorscontrollergetauthor) | **GET** /authors/{id} | 
[*AuthorsApi*](doc/AuthorsApi.md) | [**authorsControllerGetAuthors**](doc/AuthorsApi.md#authorscontrollergetauthors) | **POST** /authors | 
[*BookGroupsApi*](doc/BookGroupsApi.md) | [**bookGroupsControllerGetAllBookGroups**](doc/BookGroupsApi.md#bookgroupscontrollergetallbookgroups) | **GET** /book-groups | 
[*BooksApi*](doc/BooksApi.md) | [**booksControllerGetAllOwnedBooks**](doc/BooksApi.md#bookscontrollergetallownedbooks) | **GET** /books/owned | 
[*BooksApi*](doc/BooksApi.md) | [**booksControllerGetBook**](doc/BooksApi.md#bookscontrollergetbook) | **GET** /books/{isbn} | 
[*BooksApi*](doc/BooksApi.md) | [**booksControllerGetBookCover**](doc/BooksApi.md#bookscontrollergetbookcover) | **GET** /books/cover/{id}.png | 
[*BooksApi*](doc/BooksApi.md) | [**booksControllerGetBookOwnershipStatus**](doc/BooksApi.md#bookscontrollergetbookownershipstatus) | **GET** /books/{isbn}/status | 
[*BooksApi*](doc/BooksApi.md) | [**booksControllerSetBookOwnershipFlags**](doc/BooksApi.md#bookscontrollersetbookownershipflags) | **POST** /books/status | 
[*BooksApi*](doc/BooksApi.md) | [**booksControllerSetBookOwnershipStatus**](doc/BooksApi.md#bookscontrollersetbookownershipstatus) | **POST** /books/{isbn}/status | 
[*PublishersApi*](doc/PublishersApi.md) | [**publishersControllerGetPublisher**](doc/PublishersApi.md#publisherscontrollergetpublisher) | **GET** /publishers/{id} | 
[*PublishersApi*](doc/PublishersApi.md) | [**publishersControllerGetPublishers**](doc/PublishersApi.md#publisherscontrollergetpublishers) | **POST** /publishers | 
[*ReportsApi*](doc/ReportsApi.md) | [**reportsControllerBanUser**](doc/ReportsApi.md#reportscontrollerbanuser) | **GET** /reports/ban | 
[*ReportsApi*](doc/ReportsApi.md) | [**reportsControllerCreateReport**](doc/ReportsApi.md#reportscontrollercreatereport) | **POST** /reports | 
[*ReportsApi*](doc/ReportsApi.md) | [**reportsControllerDismissReport**](doc/ReportsApi.md#reportscontrollerdismissreport) | **GET** /reports/dismiss | 
[*SystemApi*](doc/SystemApi.md) | [**systemControllerGetSystemHealth**](doc/SystemApi.md#systemcontrollergetsystemhealth) | **GET** /system/health | 
[*SystemApi*](doc/SystemApi.md) | [**systemControllerGetSystemInfo**](doc/SystemApi.md#systemcontrollergetsysteminfo) | **GET** /system/info | 
[*SystemApi*](doc/SystemApi.md) | [**systemControllerReset**](doc/SystemApi.md#systemcontrollerreset) | **POST** /system/reset | 
[*UsersApi*](doc/UsersApi.md) | [**usersControllerGetUser**](doc/UsersApi.md#userscontrollergetuser) | **GET** /users | 
[*UsersApi*](doc/UsersApi.md) | [**usersControllerGetUserFlags**](doc/UsersApi.md#userscontrollergetuserflags) | **GET** /users/flags | 
[*UsersApi*](doc/UsersApi.md) | [**usersControllerPatchUserFlags**](doc/UsersApi.md#userscontrollerpatchuserflags) | **PATCH** /users/flags | 


## Documentation For Models

 - [AmazonDto](doc/AmazonDto.md)
 - [AuthorDto](doc/AuthorDto.md)
 - [AuthorListDto](doc/AuthorListDto.md)
 - [BasicUserDto](doc/BasicUserDto.md)
 - [BookDto](doc/BookDto.md)
 - [BookGroupDto](doc/BookGroupDto.md)
 - [BookGroupListDto](doc/BookGroupListDto.md)
 - [BookListDto](doc/BookListDto.md)
 - [ChangePasswordDto](doc/ChangePasswordDto.md)
 - [CreateReportDto](doc/CreateReportDto.md)
 - [GetIdListDto](doc/GetIdListDto.md)
 - [IdentifierDto](doc/IdentifierDto.md)
 - [LegalDto](doc/LegalDto.md)
 - [NewPasswordDto](doc/NewPasswordDto.md)
 - [OwnershipStatusDto](doc/OwnershipStatusDto.md)
 - [PublisherDto](doc/PublisherDto.md)
 - [PublisherListDto](doc/PublisherListDto.md)
 - [RecaptchaDto](doc/RecaptchaDto.md)
 - [ReportsDto](doc/ReportsDto.md)
 - [ResetPasswordDto](doc/ResetPasswordDto.md)
 - [ResetPasswordRequestDto](doc/ResetPasswordRequestDto.md)
 - [SessionDto](doc/SessionDto.md)
 - [SessionListDto](doc/SessionListDto.md)
 - [SetOwnershipFlagsDto](doc/SetOwnershipFlagsDto.md)
 - [SetOwnershipStatusDto](doc/SetOwnershipStatusDto.md)
 - [SignInDto](doc/SignInDto.md)
 - [SignInSuccessDto](doc/SignInSuccessDto.md)
 - [SignUpDto](doc/SignUpDto.md)
 - [SystemHealthDto](doc/SystemHealthDto.md)
 - [SystemInfoDto](doc/SystemInfoDto.md)
 - [UserDto](doc/UserDto.md)
 - [UserFlagsDto](doc/UserFlagsDto.md)
 - [UserFlagsPatchDto](doc/UserFlagsPatchDto.md)
 - [UserTokenDto](doc/UserTokenDto.md)


## Documentation For Authorization


Authentication schemes defined for the API:
### bearer

- **Type**: API key
- **API key parameter name**: authorization
- **Location**: HTTP header


## Author



